// translate OUT_OF_CORE I/O
//
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include <stdio.h>
//#include <math.h>

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"
//extern "C" int strcasecmp(...);

#define MAX_DIM 7
#define MAXVALUE 10

//this two dimension impdo_ioref means:
//each implied_do matches several io_reference
//it records ioref's global number

int impdo_ioref[MAXVALUE][MAXVALUE];

//tileSize's value     :    max(min(RECORD_SIZE,(u-l)/s),1)
SgExpression *tileExp[MAX_DIM];

//tileSize's expression:    pcrc_ST_i
SgExpression *tileSize[MAX_DIM];

//ioC.cc
extern SgAssignStmt *number_assign(SgSymbol *, SgExpression *,int);
extern int is_format_io(SgInputOutputStmt *print);
//foralloc.cc
//extern get_exp_in_exp(SgExpression *, SgExpression *);
extern SgExpression* get_exp_in_exp(SgExpression *, SgExpression *);

//**********************************************************************

void  calculate_tileExp(SgInputOutputStmt *print,Impdo_header_def *ihdef, SgExpression **l,SgExpression **u, SgExpression **s,SgSymbol **symb);
void impdo_ioref_relation(SgInputOutputStmt *print);
int isIooc(SgInputOutputStmt *print);
void add_iooc_coef(SgInputOutputStmt *old_print, SgInputOutputStmt *print);
SgForStmt * simple_construct_new_doloop(SgStatement *print,SgStatement *sub_print, SgSymbol **tab_symb, SgExpression **l, SgExpression **u, SgExpression **s, int n, SgExpression **tileSize);
SgInputOutputStmt * construct_sub_print(SgExpression *exprlist,SgExpression *speclist,SgInputOutputStmt *print);
SgAssignStmt * construct_stride_assign(SgStatement *s,SgSymbol * arraySym,char * stride,int var_num, int i_dim);
SgAssignStmt * construct_number_assign(SgInputOutputStmt *print,SgSymbol * arraySym,Impdo_header_def *ihdef,SgExpression *size,int i_dim );
void add_oc_read_or_write(int *ioref_dim_num,Impdo_header_def *ihdef, SgInputOutputStmt *old_print, SgInputOutputStmt *print, SgInputOutputStmt *new_print, int cur_ioref_num, SgForStmt *doloop, SgExpression **size);
void modify_outofcore_subscripts(SgInputOutputStmt *old_print,int irefNum,SgExpression *arrayRefExp,SgSymbol **tab_symb,SgExpression **tab_exp);
void modify_incore_subscripts(SgInputOutputStmt *new_print,SgExpression *arrayRefExp,int count, SgSymbol **tab_symb);
void modify_print(SgInputOutputStmt *old_print,SgInputOutputStmt *new_print, Impdo_header_def *ihdef,int *ref, SgExpression **size,int *iooc_flag,int ioref_num);
void split_impdo(SgInputOutputStmt *old_print, SgInputOutputStmt *print,int *ioref_dim_num);
void trans_iooc(SgInputOutputStmt * old_print,SgStatement *ifstmt, int *ioref_dim_num);

//***********************************************************************

//check whether pcrc_read/pcrc_write can continually read/write  
//return 0: can
//storage==COLUMN_MAJOR    ((a(i,j),i=1,N),j=1,M)
//storage==ROW_MAJOR       ((a(i,j),j=1,M),i=1,N)
//other forms are all as follows:
//return 1: cannot  

int check_order(Impdo_header_def *ihdef,io_reference *iref)
{
  SgSymbol *arraysymb =  iref->symbol();
  int subNum=((SgArrayType*)(arraysymb->type()))->dimension();
  int indexNum=ihdef->numberOfIndex();
  int i,j,indexcounter,dimcounter;

  int storage = getArrayStorage(arraysymb);
 
  //subNum >= indexNum  && iref->ihdef!=NULL 

  if(storage==COLUMN_MAJOR)
  {
    if(subNum==indexNum)
    {
      for(i=0;i<subNum; i++)
       {
         indexcounter=iref->indexSequenceOnDim(i);
         if(indexcounter==i) continue;
         else return (1); 
       }
      return (0);
    }
    else       //subNum!=indexNum
    {
      if (indexNum==1) return (0);
      else 
        {
         dimcounter=0;
         for(i=0;i<subNum; i++)
         { 
           indexcounter=iref->indexSequenceOnDim(i);
           if(indexcounter!=-1)
            {
              if(dimcounter==indexcounter) { dimcounter++; continue; }
              else return(1);
            } 
         }
         return (0);
        }
    } 
  }
  else       //ROW_MAJOR
  {
    if(subNum==indexNum)
    {
      for(i=0;i<subNum; i++)
      {
         indexcounter=iref->indexSequenceOnDim(i);
         if(indexcounter==(indexNum-1-i)) continue;
         else return (1); 
      }
      return(0);
    }
    else    //subNum!=indexNum
     {
       if (indexNum==1) return (0);
       else 
        {
         dimcounter=0;
         for(i=0;i<subNum; i++)
         { 
           indexcounter=iref->indexSequenceOnDim(i);
           if(indexcounter!=-1)
            {
              if(indexcounter==(indexNum-1-dimcounter)) { dimcounter++; continue; }
              else return(1);
            } 
         }
         return(0);
        }
     }
  }

}

// tileExp,tileSize
void  calculate_tileExp(SgInputOutputStmt *print,Impdo_header_def *ihdef, SgExpression **l,SgExpression **u, SgExpression **s,SgSymbol **symb)
{
  int index_num=ihdef->numberOfIndex();
  int i;
  SgSymbol *minSymb=print->getSymbolInCurrentScope("min");
  SgSymbol *maxSymb=print->getSymbolInCurrentScope("max");

  // for remote sensing: RECORD_SIZE is a variable
  // SgVarRefExp
  SgExpression *incore = get_record_size(print);
  SgExpression *multiplyExp=new SgValueExp(1);
  for(i=0; i<index_num; i++)
  {
    SgFunctionCallExp *minExp=new SgFunctionCallExp(*minSymb);
    SgFunctionCallExp *maxExp=new SgFunctionCallExp(*maxSymb);
    SgExpression *first=&(*incore->copyPtr() / (*multiplyExp->copyPtr()));
    first=calculateExp(first);
    minExp->addArg(*first);
    SgExpression *second=&((*u[i]->copyPtr()-*l[i]->copyPtr()) / (*s[i]->copyPtr())+ *(new SgValueExp(1)));
    second=calculateExp(second);
    minExp->addArg(*second);
    maxExp->addArg(*minExp);
    maxExp->addArg(*(new SgValueExp(1)));
    tileExp[i]=maxExp;
    multiplyExp=&(*multiplyExp * *tileExp[i]->copyPtr());

    // create a set of symbol expression  pcrc_ST_i, pcrc_ST_j ...
    SgSymbol *sizeSymb=print->getSymbolInCurrentScope(mixstring,"ST",symb[i]->identifier());
    tileSize[i]= new SgVarRefExp(sizeSymb);
     
  }
  
}


//create mapping between impdo and ioref
//because one impdo could include several ioref ,( (a(i,j),b(i,j),i=l:u:s),j=ll:uu:ss)
//for example: print *, a(1,2),(b(i,j),d(i,j),i=1,N),j=1,M),x,4+5,(c(i),i=1,5)
//ioref_num=4(0,1,2,3)  impdo_num=2(0,1)
//impdo_ioref[0][0]=1, impdo_ioref[0][1]=2, impdo_ioref[1][0]=3

void impdo_ioref_relation(SgInputOutputStmt *print)
{
   int num,i,j,num1;
   int impdo_num,ioref_num;
   Impdo_header_def *temp_ihdef=NULL;

   impdo_num=print->numberOfAttributes(IHDER_Def);
   ioref_num=print->numberOfAttributes(Io_Ref);

   i=0;
   j=0;
   for(num1=0;num1<impdo_num;num1++)
     for(num=i;num<ioref_num;num++)
     {
      io_reference *iref = (io_reference *) print->attributeValue(num, Io_Ref);
      Impdo_header_def *ihdef = iref->ihdef;
      if (ihdef == NULL) continue;
      if((temp_ihdef==NULL) && (ihdef!=NULL))
          impdo_ioref[num1][j]=num;
      else 
         if(temp_ihdef==ihdef)
           impdo_ioref[num1][j]=num;
         else 
           { temp_ihdef=NULL; j=0; i=num; break; }
      j=j+1; 
      temp_ihdef=ihdef;
     }   
}

//check whether there is outofcore_array in implied_do
//return 1: outofcore

int isIooc(SgInputOutputStmt *print)
{
   int num;
   int ioref_num=print->numberOfAttributes(Io_Ref);

   for ( num=0; num <ioref_num ; num++)
   {
     io_reference * iref = (io_reference *) print->attributeValue(num, Io_Ref);
     Impdo_header_def *ihdef = iref->ihdef;
	// optimize: if the array is one dimension refered, we donot do it in out-of-core mode.
     if(is_out_of_core(iref->symbol()) && ihdef && ihdef->numberOfIndex() > 1)
          return 1;
   }
   return 0;
}

//  add  pcrc_coef() to OUT_OF_CORE's io_reference (iref->ihdef!=NULL)
//  it will be called by trans_iooc().

void add_iooc_coef(SgInputOutputStmt *old_print, SgInputOutputStmt *print)
{
   int num,i,num1;
   int impdo_num,ioref_num;
   impdo_num=old_print->numberOfAttributes(IHDER_Def);
   ioref_num=old_print->numberOfAttributes(Io_Ref);

    for(num=0; num<ioref_num; num++)
    {
     io_reference * iref = (io_reference *) old_print->attributeValue(num, Io_Ref);
     if (is_out_of_core(iref->symbol()) > 0)
    { 
     Impdo_header_def * ihdef = iref->ihdef;
     int dimNum=((SgArrayType *)iref->symbol()->type())->dimension();
     int dimcounter=0;
     for(i=0;i<dimNum;i++)  
     {
       if (iref->hasIndexOnDim(i))
       {
       dimcounter++;
       SgSymbol *dad=old_print->getSymbolInCurrentScope(mixstring, "tdd",NULL ,num);
       int indexcounter=iref->indexSequenceOnDim(i);
       SgExpression * l=ihdef->getIndexTriplet(indexcounter, 0)->copyPtr();
       SgExpression * u=ihdef->getIndexTriplet(indexcounter, 1)->copyPtr();
       SgExpression * s=ihdef->getIndexTriplet(indexcounter, 2)?ihdef->getIndexTriplet(indexcounter, 2)->copyPtr():(new SgValueExp(1));
       SgExpression *stride=new SgValueExp(1);
       SgExpression *offset=new SgValueExp(0);
       SgStatement *coef=make_coef(old_print,dad,dimcounter,l,u,s,stride,offset,new SgValueExp(0),num,dimcounter-1);
       print->insertStmtBefore(*coef, *print->controlParent());
       }
     }
    }     //end of  Out_ofcore
   }      //end of Io_Ref
}

// when there is out_of_core array in old_print,
// loop_tile for impdo.
// one whole impdo is only tiled once,
// as though it may contain several io_reference.

SgForStmt * simple_construct_new_doloop(SgStatement *print,SgStatement *sub_print, SgSymbol **tab_symb, SgExpression **l, SgExpression **u, SgExpression **s, int n, SgExpression **tileSize)
{
 SgForStmt *newloop;
 int i;
 SgExpression *ll[MAX_DIM], *uu[MAX_DIM], *ss[MAX_DIM],*size[MAX_DIM];
 SgSymbol *symb[MAX_DIM];
 for(i=0;i<n;i++)
  {
    ll[i]=l[i]->copyPtr();
    uu[i]=u[i]->copyPtr();
    ss[i]=s[i]->copyPtr();
    size[i]=tileSize[i]->copyPtr();
    symb[i]=print->getSymbolInCurrentScope(mixstring, "T",tab_symb[i]->identifier());
  }

 newloop=(SgForStmt *)sub_print->copyPtr();
 for(i=0; i<n; i++)
  {
    int result;
    if(ss[i]->valueInteger(result)!=-1) 
      if(result!=1)
       {
        uu[i]=&(*(uu[i]->copyPtr()) / *(ss[i]->copyPtr()));
        uu[i]=calculateExp(uu[i]);
        ss[i]=size[i];
       }
    newloop=new SgForStmt(symb[i],ll[i],uu[i],size[i],newloop);
  }

  return newloop;
}
 
// extract old_print's sub_statement to make new print
// print *,(a(i),i=1,N),x,c(2,1)
// (1)print *,(a(i),i=1,N)
// (2)print *,x
// (3)print *,c(2,1)

SgInputOutputStmt * construct_sub_print(SgExpression *exprlist,SgExpression *speclist,SgInputOutputStmt *print)
{
     SgInputOutputStmt *sub_print=NULL;

     if(exprlist!=NULL)  {
        SgExpression *expr=new SgExpression(EXPR_LIST,exprlist->copyPtr(),NULL,NULL); 
	switch(print->variant())
	{
	 case READ_STAT:
	      sub_print=new SgInputOutputStmt(READ_STAT,*speclist->copyPtr(),*expr->copyPtr());
	      break;
         case WRITE_STAT:
	      sub_print=new SgInputOutputStmt(WRITE_STAT,*speclist->copyPtr(),*expr->copyPtr());
	      break;
         case PRINT_STAT:
	      sub_print=new SgInputOutputStmt(PRINT_STAT,*speclist->copyPtr(),*expr->copyPtr());
	      break;
        }
     }

     return sub_print;
}

// pcrc_oc_stride()=...
// add_oc_read_or_write() will call it

SgAssignStmt * construct_stride_assign(SgStatement *s,SgSymbol * arraySym,char * stride,int var_num, int i_dim)
{
    SgSymbol * RstrideSym=s->getSymbolInCurrentScope(mixstring, stride,NULL,var_num,i_dim);
   SgExpression * RstrideExp = new SgVarRefExp(RstrideSym);

    SgArrayRefExp * aryExp=new SgArrayRefExp (*arraySym);
    SgExpression * valExp= new SgValueExp(i_dim+1);
    aryExp->addSubscript(*valExp);
    SgAssignStmt * assignStmt = new SgAssignStmt(*aryExp, *RstrideExp);
    return(assignStmt);

}

// pcrc_oc_number()=...
// add_oc_read_or_write() will call it

SgAssignStmt * construct_number_assign(SgInputOutputStmt *print,SgSymbol * arraySym,Impdo_header_def *ihdef,SgExpression *size,int i_dim ,int dimcounter)
{
    SgSymbol *minSymb=print->getSymbolInCurrentScope("min");
    SgFunctionCallExp *minExp= new SgFunctionCallExp(*minSymb);
    SgSymbol * indexSymb=print->getSymbolInCurrentScope(mixstring, "T",ihdef->indexSymbol(i_dim)->identifier());
    SgVarRefExp *varrefexp=new SgVarRefExp(indexSymb);
    SgExpression *first=&(*varrefexp->copyPtr()+*size->copyPtr()-*(new SgValueExp(1)));
    first=calculateExp(first);
    minExp->addArg(*first);
    SgExpression *s=ihdef->getIndexTriplet(i_dim,2)?ihdef->getIndexTriplet(i_dim,2)->copyPtr():(new SgValueExp(1));
    SgExpression *second=&(*ihdef->getIndexTriplet(i_dim,1)->copyPtr()/(*s));
    second=calculateExp(second);
    minExp->addArg(*second);
    SgExpression *numberExp=&(*minExp-*varrefexp+*(new SgValueExp(1)));
    numberExp=calculateExp(numberExp);

    SgArrayRefExp * aryExp=new SgArrayRefExp (*arraySym);
    SgExpression * valExp= new SgValueExp(dimcounter+1);
    aryExp->addSubscript(*valExp);
    SgAssignStmt * assignStmt = new SgAssignStmt(*aryExp, *numberExp);
    return(assignStmt);
}

// call pcrc_oc_read()
// call pcrc_oc_write()
// for each (out_of_core && impdo) io_reference

void add_oc_read_or_write(Impdo_header_def *ihdef, SgInputOutputStmt *old_print, SgInputOutputStmt *print, SgInputOutputStmt *new_print, int cur_ioref_num, SgForStmt *doloop,SgExpression **size)
{
        int i;

        // create pcrc_tdd, pcrc_tbs
        SgSymbol *dad=print->getSymbolInCurrentScope(mixstring, "tdd",NULL ,cur_ioref_num);
        SgSymbol *stack_symb=print->getSymbolInCurrentScope(mixstring, "tbs",NULL ,cur_ioref_num);
        SgVarRefExp *stack_exp=new SgVarRefExp(stack_symb);

        // create pcrc_sdx
        SgSymbol *start_symb=print->getSymbolInCurrentScope(mixstring, "sdx",NULL ,cur_ioref_num);
        SgVarRefExp *start=new SgVarRefExp(start_symb);

        // create real_mb
        io_reference *iref=(io_reference *)old_print->attributeValue(cur_ioref_num,Io_Ref);
        SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
        SgSymbol * arraysymb  = array->symbol();

#ifdef MEM_ALLOC
//  SgSymbol * newsymb = print->getSymbolInCurrentScope(stackNameOfType(arraysymb->type()),"mb", NULL);
  SgSymbol * newsymb = print->getSymbolInCurrentScope(stackNameOfType(array->type()),"mb", NULL);
#else
//  SgSymbol * newsymb = print->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL);
  SgSymbol * newsymb = print->getSymbolInCurrentScope(mixstring, stackNameOfType(array->type()), NULL);
#endif

        SgArrayRefExp *newarray = new SgArrayRefExp(*newsymb);

        //  generate real_mb(pcrc_tbs)
        newarray->addSubscript(*stack_exp);

        // generate pcrc_oc_stride && pcrc_oc_number
        SgSymbol *stride_symb=print->getSymbolInCurrentScope(mixstring, "oc_stride",NULL ,cur_ioref_num);
        SgSymbol *number_symb=print->getSymbolInCurrentScope(mixstring, "oc_number",NULL ,cur_ioref_num);

        switch(new_print->variant())
         {
	  case READ_STAT:
	     {
	       SgStatement *write=make_oc_write(print,dad,newarray,start,stride_symb,number_symb);
	       new_print->insertStmtAfter(*write, *new_print->controlParent());
	       break;
	     } 
	  case WRITE_STAT: 
          case PRINT_STAT:
	     {
	       SgStatement *read=make_oc_read(print,dad,newarray,start,stride_symb,number_symb);
	       new_print->insertStmtBefore(*read, *new_print->controlParent());
	       break;
	     }
          }

       // insert pcrc_oc_stride0(1)=pcrc_u00
       for(i=0;i<ihdef->numberOfIndex();i++)
       {
        SgAssignStmt *strideAssignStmt=construct_stride_assign(print,stride_symb,"u",cur_ioref_num,i);
        doloop->insertStmtBefore(*strideAssignStmt,*doloop->controlParent()); 
        }  

	SgForStmt *temloo = doloop;
	for(i=0;i<ihdef->numberOfIndex()-1;i++)
           temloo = isSgForStmt(temloo->getNextLoop());  

       // insert pcrc_sdx0=pcrc_T_i*pcrc_u00+pcrc_v00+...  

       int numOfSubscripts=((SgArrayType*)(iref->symbol()->type()))->dimension();
       int dimcounter=0;
       SgExpression *startR=NULL;
       for(i=0; i<numOfSubscripts; i++)
       {
         SgVarRefExp *u,*v,*index;
         SgExpression *uv;
         SgSymbol *u_symb,*v_symb,*index_symb;
         int sequence=iref->indexSequenceOnDim(i);
         if(sequence!=-1)
          {
           v_symb=old_print->getSymbolInCurrentScope(mixstring,"v",NULL,cur_ioref_num,dimcounter);
           v=new SgVarRefExp(v_symb); 
           u_symb=old_print->getSymbolInCurrentScope(mixstring,"u",NULL,cur_ioref_num,dimcounter);
           u=new SgVarRefExp(u_symb);
           index_symb=old_print->getSymbolInCurrentScope(mixstring,"T",ihdef->indexSymbol(sequence)->identifier()); 
           index=new SgVarRefExp(index_symb);
           uv=&(*v + *u * *index); 
           startR=startR + *uv;
           dimcounter++;
          }          
         else  continue; //this dim is scalar dim
//           startR=startR + *v;
       } 
       SgAssignStmt *startAssignStmt=new SgAssignStmt(*start,*startR);
       switch(new_print->variant())
       {
         case READ_STAT:
              new_print->insertStmtBefore(*startAssignStmt,*new_print->controlParent());
              break;
         case WRITE_STAT:
         case PRINT_STAT:
            temloo->insertStmtAfter(*startAssignStmt,*temloo);
            break;
        }
        
      // insert pcrc_oc_number0(1)=min(pcrc_T_i+tileSize-1,(ui-li)/si)-pcrc_T_i+1 

     dimcounter=0;
     for(i=0;i<numOfSubscripts;i++)  
     {
       if (iref->hasIndexOnDim(i))
       {
         int indexcounter=iref->indexSequenceOnDim(i);
//printf("indexcounter:%d\n",indexcounter);
         SgAssignStmt *numberAssignStmt=construct_number_assign(print,number_symb,ihdef,size[indexcounter],indexcounter,dimcounter);
         switch(new_print->variant())
        {
         case READ_STAT:
            new_print->insertStmtBefore(*numberAssignStmt,*new_print->controlParent());
            break;  
         case PRINT_STAT:
         case WRITE_STAT:
            temloo->insertStmtAfter(*numberAssignStmt,*temloo);
            break;
        }
         dimcounter++;
       } 
     }
}


// modify new_print's io_reference(out_of_core)'s subscripts
// modify_print() will call it

void modify_outofcore_subscripts(SgInputOutputStmt *old_print,int irefNum,SgExpression *arrayRefExp,SgSymbol **tab_symb,SgExpression **tab_exp)
{
//count: index variable number in current impdo 
  int i,j,flag=0;     
  SgExpression *expr;
  SgExpression *add_op=arrayRefExp->lhs()->lhs();
  io_reference *iref=(io_reference *)old_print->attributeValue(irefNum,Io_Ref);

  SgSymbol *arraysymb = iref->symbol();
  int numOfSubScripts=((SgArrayType *)arraysymb->type())->dimension();
  SgExpression *temp_exp[MAXVALUE];
  SgSymbol *temp_symb[MAXVALUE];

  int storage = getArrayStorage(arraysymb);

  // ((a(i,j),i=...),j=...)
  // COLUMN_MAJOR: int_mb(pcrc_tbs0+i+[i]*j)
  // ROW_MAJOR   : int_mb(pcrc_tbs0+j+[j]*i)
  // order of temp_exp[] is arranged according to order of (i,j,k) in int_mb()
  j=0;
  if(storage==COLUMN_MAJOR)
      for(i=numOfSubScripts-1; i>=0;i--)
     {
      int site=iref->indexSequenceOnDim(i);
      if(site!=-1)
      {
        temp_symb[j]=tab_symb[site];
        temp_exp[j]=tab_exp[site];
        j=j+1;
      }
     }
   else
      for(i=0; i<numOfSubScripts; i++ )
     {
      int site=iref->indexSequenceOnDim(i);
      if(site!=-1)
      {
        temp_symb[j]=tab_symb[site];
        temp_exp[j]=tab_exp[site];
        j=j+1;
      }
     }

   int total=j;
   j=0;
  if(add_op->variant()==ADD_OP) 
   for(expr=add_op; expr; expr=expr->lhs())
  {
    if((expr->rhs()!=NULL) && (expr->rhs()->variant()==MULT_OP))
    {
     SgExpression *mult_op=expr->rhs();
     if(mult_op->rhs()->symbol()==temp_symb[j])
        {
          SgExpression *multiply=NULL;
          for(i=j+1;i<total;i++) 
             multiply=multiply * *temp_exp[i]->copyPtr();
          j=j+1;
          mult_op->lhs()->replace(*multiply->copyPtr());    
        }
    }

  }
}

// modify new_print's io_reference(in_core)'s subscripts
// modify_print() will call it

void modify_incore_subscripts(SgInputOutputStmt *new_print,SgExpression *arrayRefExp,int count, SgSymbol **tab_symb)
{
      // this kind of method is fit for in_core array mixed with out_of_core array
      // real_mb(pcrc_tbs0+i+numi*j+(numi*numj)*k+...)
      // after tiling:
      // real_mb(pcrc_tbs0+i+pcrc_T_i+numi*(j+pcrc_T_j)+(numi*numj)*(k+pcrc_T_k)+...)
      // where numi,numj... are that dimension num corresponding to Dim i,j...
    int i;
    SgExpression *expr;
    for(i=0; i<count;i++)
    {
     expr=arrayRefExp->IsSymbolInExpression(*tab_symb[i]);
     if(expr!=NULL)
       {
       SgSymbol * indexSymb=new_print->getSymbolInCurrentScope(mixstring, "T",tab_symb[i]->identifier());
       SgVarRefExp *TExp=new SgVarRefExp(indexSymb);
       SgExpression *newExp=&(*expr->copyPtr()+ *TExp);
       expr->replace(*newExp);       
       }
    }

}

SgAssignStmt * construct_index_assign(SgInputOutputStmt *print,SgSymbol *arraySym,int i,int indexcounter)
{
    SgExpression *indexExp=new SgValueExp(i);

    SgArrayRefExp * aryExp=new SgArrayRefExp (*arraySym);
    SgExpression * valExp= new SgValueExp(indexcounter+1);
    aryExp->addSubscript(*valExp);
    SgAssignStmt * assignStmt = new SgAssignStmt(*aryExp, *indexExp);
    return(assignStmt);
}

SgForStmt * temp_stack_doloop(SgStatement *s, io_reference *iref,  SgArrayRefExp *tempNewArray,
            SgVarRefExp *stack_exp,SgArrayRefExp * numberExp,int irefNum)
{

     SgSymbol *index=s->getSymbolInCurrentScope(mixstring,"sdx",NULL);
     SgVarRefExp *indexExpression=new SgVarRefExp(index); 
     int i;
     SgExpression *number=new SgValueExp(1);
     for(i=0; i<iref->ihdef->numberOfIndex();i++)
      {  
        SgArrayRefExp *temp=(SgArrayRefExp *)numberExp->copyPtr(); 
        temp->addSubscript(*(new SgValueExp(i+1)));
        number=&(*number * *temp);
      }
     number=&(*number - *(new SgValueExp(1))); 
     number=calculateExp(number);
     SgExpression *exp=new SgValueExp(0);
     // assign statement-----body of loop  
     tempNewArray->addSubscript(*stack_exp + *indexExpression);
     SgArrayRefExp *arrayExp=(SgArrayRefExp *)get_exp_in_exp(iref->getFunction(),iref->expression());
     ASSERT(arrayExp); 
     SgSymbol *  temp_symb=s->getSymbolInCurrentScope(mixstring, "tbs",NULL ,irefNum);
     SgVarRefExp * temp_exp=new SgVarRefExp(*temp_symb);
     SgExpression *lhs=&(*temp_exp  + *indexExpression); 
     SgExpression *exprlist=new SgExpression(EXPR_LIST,lhs,NULL,NULL);
     arrayExp->setSubscripts(*exprlist);
     SgAssignStmt *assignStmt=new SgAssignStmt(*tempNewArray,*iref->getFunction());
     SgForStmt *doloop=new SgForStmt(index,exp,number,NULL,assignStmt);
   
     return doloop;
}  
// because of IO_C , so we call C language's read or write
// call pcrc_read(unit,byte_mb(pcrc_tbs),dim,major,order,
// pcrc_oc_number,pcrc_size_byte)
// call pcrc_write(unit,byte_mb(pcrc_tbs),dim,major,order,
// pcrc_oc_number,pcrc_size_byte)

void rewriteIoStmt(SgInputOutputStmt *old_print,int irefNum,SgInputOutputStmt *new_print,int flag)
{
  int i,j,dimcounter;
  io_reference *iref=(io_reference *)old_print->attributeValue(irefNum,Io_Ref);

  SgSymbol *indexSymb=old_print->getSymbolInCurrentScope(mixstring,"oc_index",NULL,irefNum);
  SgSymbol *number_symb=old_print->getSymbolInCurrentScope(mixstring, "oc_number",NULL ,irefNum);

  SgSymbol *arraysymb = iref->symbol();
  int numOfSubscripts=((SgArrayType*)(arraysymb->type()))->dimension();

  int storage = getArrayStorage(arraysymb);

  if((old_print->variant()==READ_STAT) || (old_print->variant()==WRITE_STAT))
  {
  // only fit for the situation: numOfSubscripts == iref->ihdef->numberOfIndex()
  dimcounter=0;
  for(i=0;i<numOfSubscripts;i++)  
   {
     if (iref->hasIndexOnDim(i))
     {
       int indexcounter=iref->indexSequenceOnDim(i);
       SgAssignStmt *indexAssignStmt=construct_index_assign(old_print,indexSymb,dimcounter,indexcounter);
       new_print->insertStmtBefore(*indexAssignStmt,*new_print->controlParent());
       dimcounter++;
     }
   } 

   if(flag==0)
   {
    dimcounter=0;
    for(i=0;i<numOfSubscripts;i++)  
     {
       if (iref->hasIndexOnDim(i))
       {
         int indexcounter=iref->indexSequenceOnDim(i);
         SgExpression *l=iref->ihdef->getIndexTriplet(dimcounter, 0);
         SgExpression *u=iref->ihdef->getIndexTriplet(dimcounter, 1);
         SgExpression *s=iref->ihdef->getIndexTriplet(dimcounter, 2)?iref->ihdef->getIndexTriplet(dimcounter, 2):(new SgValueExp(1));
         SgExpression *numberExp=&((*u->copyPtr() - *l->copyPtr()) / (*s->copyPtr()) + *(new SgValueExp(1)));  
         numberExp=calculateExp(numberExp); 
         SgAssignStmt *numberAssignStmt=number_assign(number_symb,numberExp,dimcounter);
         new_print->insertStmtBefore(*numberAssignStmt,*new_print->controlParent());
         dimcounter++;
       } 
     }
   }

   SgSymbol *printSymb;
   switch(old_print->variant())
   {
    case READ_STAT:
         printSymb=old_print->getSymbolInCurrentScope(mixstring,"read",NULL);
         break;
    case WRITE_STAT:
         printSymb=old_print->getSymbolInCurrentScope(mixstring,"write",NULL);
         break;
    } 
   SgCallStmt *print=new SgCallStmt(*printSymb);

// create argument 1
    SgExpression *specList=old_print->specList();
    SgExpression *expr,*unitExp;
    for(expr=specList; expr; expr=expr->rhs())
     {
       SgExpression *keyParent=expr->lhs();
       SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
       if(keyword != NULL )
         if(strcasecmp(keyword->value(),"unit")==0)
         {
          unitExp=keyParent->rhs()->copyPtr();
          break;
         } 
     }
   print->addArg(*unitExp);

// create argument 2
        //  generate real_mb(pcrc_tbs)
     SgSymbol *stack_symb, *newsymb;
     if((iref->getFunction()!=NULL) &&  (old_print->variant()==WRITE_STAT))
       stack_symb=old_print->getSymbolInCurrentScope(mixstring, "tbs",NULL);
     else
       stack_symb=old_print->getSymbolInCurrentScope(mixstring, "tbs",NULL ,irefNum);
     SgVarRefExp *stack_exp=new SgVarRefExp(stack_symb);
     SgArrayRefExp * array = (SgArrayRefExp *) iref->expression();  
     SgSymbol * arraysymb  = array->symbol();

#ifdef MEM_ALLOC
  if ((iref->getFunction()!=NULL) && (old_print->variant()==WRITE_STAT))
    newsymb=old_print->getSymbolInCurrentScope(stackNameOfType(iref->getFunction()->type()),"mb",NULL);
  else
    newsymb = old_print->getSymbolInCurrentScope(stackNameOfType(array->type()),"mb", NULL);
#else
  newsymb = old_print->getSymbolInCurrentScope(mixstring, stackNameOfType(array->type()), NULL);
#endif

     SgArrayRefExp *newarray = new SgArrayRefExp(*newsymb);
     SgArrayRefExp *tempNewArray=(SgArrayRefExp *)newarray->copyPtr();
     newarray->addSubscript(*stack_exp);

     print->addArg(*newarray->copyPtr());

// create argument 3
    if(iref->ihdef!=NULL)
    {
    int dim=iref->ihdef->numberOfIndex();
    SgValueExp *dimExp=new SgValueExp(dim);
    print->addArg(*dimExp);
    }
    else         //scalar
      print->addArg(*(new SgValueExp(0)));

// create argument 4
    SgValueExp *majorExp=new SgValueExp(storage);
    print->addArg(*majorExp);

// create argument 5
    if(iref->ihdef!=NULL)
    {
     int order=check_order(iref->ihdef,iref);
     SgValueExp *orderExp=new SgValueExp(order);
     print->addArg(*orderExp);
    }
    else      //scalar's order=0
      print->addArg(*(new SgValueExp(0)));

// create argument 6
    SgArrayRefExp * numberExp=new SgArrayRefExp (*number_symb);
    print->addArg(*numberExp->copyPtr());

// create argument 7
    SgExpression * sizeExp;
    if(iref->getFunction()!=NULL && (old_print->variant()==WRITE_STAT)) 
      sizeExp = get_type_size(old_print, iref->getFunction()->type());
    else
      sizeExp = get_type_size(old_print, array->type());
    print->addArg(*sizeExp->copyPtr());

// create argument 8
    SgArrayRefExp * indexExp=new SgArrayRefExp (*indexSymb);
    print->addArg(*indexExp->copyPtr());

    new_print->insertStmtBefore(*print,*new_print->controlParent());

//  construct new do loop for elementary intrinsic function
//  write(10) (real(a(i)),i=1,n)

    if((iref->getFunction()!=NULL) && (old_print->variant()==WRITE_STAT))
    {
     SgForStmt *doloop=temp_stack_doloop(print,iref,tempNewArray,stack_exp,numberExp,irefNum);
     print->insertStmtBefore(*doloop,*new_print->controlParent());
    }       
 
   }  // only(read,write) do

}

//modify new_print, including impdo's index variable and io_reference's subscripts 

void modify_print(SgInputOutputStmt *old_print,SgInputOutputStmt *new_print, Impdo_header_def *ihdef,int *ref, SgExpression **size,int *iooc_flag,int ioref_num)
{
   SgExpression *itemlist=new_print->itemList();
   SgExpression *impdoExp=itemlist->lhs();
   SgSymbol *minSymb=new_print->getSymbolInCurrentScope("min");
   SgSymbol *tab_symb[MAXVALUE];  //(a(i,j,k),i=..),j=..),k=..) order:k,j,i
   SgSymbol *reverse_tab_symb[MAXVALUE];  
   SgExpression *tab_exp[MAXVALUE];  //order:k,j,i
   SgExpression *reverse_tab_exp[MAXVALUE];  
   int i=0,count;
   int num=ihdef->numberOfIndex();

   // modify DDOT
   SgExpression *expr,*lastImpdo;
   for(expr=impdoExp; expr->rhs() && expr->lhs(); expr=expr->lhs()->lhs())
   {
     if(expr->variant()!=IMPLIED_DO) break;
     lastImpdo=expr;
     tab_symb[i]=expr->symbol();     
     num=num-1;
     SgTripletExp *ddot=(SgTripletExp *)expr->rhs();
     SgExpression *u=ddot->item(1);
     SgExpression *s=ddot->item(2);

     SgFunctionCallExp *minExp=new SgFunctionCallExp(*minSymb); 
     SgSymbol * indexSymb=new_print->getSymbolInCurrentScope(mixstring, "T",expr->symbol()->identifier());
     SgVarRefExp *varrefexp=new SgVarRefExp(indexSymb);
     SgExpression *first=&(*varrefexp->copyPtr()+*size[num]->copyPtr()-*(new SgValueExp(1)));
     first=calculateExp(first);
     minExp->addArg(*first);
     SgExpression *second=s?&(*u->copyPtr()/ (*s->copyPtr())):u->copyPtr();
     second=calculateExp(second);
     minExp->addArg(*second);
     SgExpression *numberExp=&(*minExp-*varrefexp);
     numberExp=calculateExp(numberExp);
     u->replace(*numberExp);
     ddot->setRhs(new SgValueExp(1));
     tab_exp[i]=&(*numberExp->copyPtr()+ *(new SgValueExp(1)));
     i=i+1;
   }

    // modify new_print's subscripts   
    //now support many  io_reference in one impdo  ((a(i,j),b(i,j),i=1,5),j=1,5)
      count=i;
      for(i=0;i<count;i++)
      {
        reverse_tab_symb[i]=tab_symb[count-1-i]; 
        reverse_tab_exp[i]=tab_exp[count-1-i]->copyPtr(); 
      }

      i=0;
       for(expr=lastImpdo->lhs(); expr; expr=expr->rhs())
       {
          //ARRAY_REF
          SgExpression *arrayRefExp=expr->lhs();
          if(iooc_flag[i]==1)
          {
           if(ioMode==IO_FORTRAN)
               modify_outofcore_subscripts(old_print,ref[i],arrayRefExp,reverse_tab_symb,reverse_tab_exp);
           else     //IO_C
              {
               if(i==0)
                   rewriteIoStmt(old_print,ref[i],new_print,1);
               else
                  {  
                   printf("Sorry,only support ONE array reference in implied_do\n");
                   exit(1);
                  }
              }
          }
          if(iooc_flag[i]==0)
          {
            if(ioMode==IO_FORTRAN)
              modify_incore_subscripts(new_print,arrayRefExp,count,tab_symb);
            else  //???   outofcore && incore are in one impdo
              {
                if(i==0)
                   rewriteIoStmt(old_print,ref[i],new_print,0);
                else
                  {  
                   printf("Sorry,only support ONE array reference in implied_do\n");
                   exit(1);
                  }
              }
          } 
          i=i+1;
       }
  
    if((ioMode==IO_C) && (new_print->variant()!=PRINT_STAT))
       new_print->deleteStmt();


}

void apply_temp_stack(SgStatement *doloop, io_reference *iref,SgExpression **tileSize)
{
  int i;
  SgStatement *stackStmt;

  if (iref->getFunction()==NULL) return;
  if ( ioMode==IO_C )
    {
     SgSymbol *base=doloop->getSymbolInCurrentScope(mixstring,"tbs",NULL);
     SgSymbol *mHandle=doloop->getSymbolInCurrentScope(mixstring,"mh",NULL);
     SgExpression *sizeExp=new SgValueExp(1);
     for(i=0; i<iref->ihdef->numberOfIndex(); i++)
       sizeExp=&(*sizeExp * *tileSize[i]->copyPtr());
     sizeExp=calculateExp(sizeExp);  
     stackStmt=make_stack_alloc_size(doloop,iref->getFunction()->type(),base,sizeExp,mHandle);
     doloop->insertStmtBefore(*stackStmt,*doloop->controlParent());
     SgStatement * funcall = make_free(doloop,iref->getFunction()->type(),mHandle);         
     doloop->insertStmtAfter(*funcall,*doloop->controlParent());
    }
}

// This the most kernel procedure
// it will call add_oc_read_or_write(),construct_sub_print(),
//simple_construct_new_doloop(), modify_print(),calculate_tileExp().
// It will be called by trans_iooc()

void split_impdo(SgInputOutputStmt *old_print, SgInputOutputStmt *print, int *ioref_dim_num)
{
   int num,i,num1,j,k;
   int impdo_num,ioref_num, cur_ioref_num=0;
   SgForStmt *temloo, *doloop;
   SgExpression *l[MAX_DIM],*u[MAX_DIM],*s[MAX_DIM];
   SgSymbol     *index_symb[MAX_DIM];
   SgInputOutputStmt *sub_print=NULL,*new_print=NULL;
   Impdo_header_def * temp_ihdef=NULL; 
   SgSymbol *dad,*stride_symb,*number_symb;
   SgArrayRefExp * newarray;
   SgVarRefExp *start;
   int iooc_flag[MAXVALUE];  // 1:outofcore; 0:incore

   //in order to recreate READ_STAT
   //SgInputOutputStmt(int variant, SgExpression &specList, SgExpression &itemList)
   SgExpression *exprlist=old_print->itemList()->copyPtr();
   SgExpression *speclist=old_print->specList()->copyPtr();

   impdo_num=old_print->numberOfAttributes(IHDER_Def);
   ioref_num=old_print->numberOfAttributes(Io_Ref);

   num = 0;

   //scan old_print->itemList()
   //when finding Outofcore_def && IHDER_Def, make a set of things

   for (SgExpression *expr = exprlist; expr; expr=expr->rhs())
   {
     SgExpression *impdoExp = expr->lhs();
     if (impdoExp->variant() != IMPLIED_DO )
     {
        sub_print=construct_sub_print(impdoExp,speclist,print);
        if(sub_print)
           print->insertStmtBefore(*sub_print,*print->controlParent()); 
     	continue;
     }
     int counter=0;
     int flag=0;
     Impdo_header_def * ihdef = (Impdo_header_def *)old_print->attributeValue(num,IHDER_Def);
     ASSERT(ihdef);

     for(i=0;i<MAXVALUE;i++)
       if(impdo_ioref[num][i]!=-1) counter=counter+1;  
     
      //counter: io_reference number in one implied_do
      //cur_ioref_num: until this time, io_reference current  number
     
     for(k=0;k<counter;k++)
    {
       io_reference *iref=(io_reference *)old_print->attributeValue(impdo_ioref[num][k],Io_Ref);

       if(is_out_of_core(iref->symbol()) > 0)
     {
   
        flag=flag+1;
       if(flag==1)   //these work is only done once
      {
       // get implied_do's lower,upper bound and step
        for ( i = 0; i< ihdef->numberOfIndex(); i++)
       {
        l[i]=ihdef->getIndexTriplet(i, 0);
        u[i]=ihdef->getIndexTriplet(i, 1);
        s[i]=ihdef->getIndexTriplet(i, 2)?ihdef->getIndexTriplet(i, 2):(new SgValueExp(1));
        index_symb[i]=ihdef->indexSymbol(i);
       } 

       calculate_tileExp(print,ihdef,l,u,s,index_symb);
       sub_print=construct_sub_print(impdoExp,speclist,print);
       if(sub_print)
       { 
	doloop=simple_construct_new_doloop(print,sub_print,index_symb,l,u,s,ihdef->numberOfIndex(),tileSize);    
	print->insertStmtBefore(*doloop,*print->controlParent());     
	temloo = doloop;
	for(i=0;i<ihdef->numberOfIndex()-1;i++)
           temloo = isSgForStmt(temloo->getNextLoop());  
        new_print=(SgInputOutputStmt *)temloo->childList1(0);
        
        // insert tileSize assign statement pcrc_ST_i=tileExp
        for(i=0;i<ihdef->numberOfIndex(); i++)
         {
           SgAssignStmt *sizeAssignStmt=new SgAssignStmt(*tileSize[i]->copyPtr(),*tileExp[i]->copyPtr());
           doloop->insertStmtBefore(*sizeAssignStmt,*doloop->controlParent());
         }

        //1998/6/5
        // for intrinsic function in WRITE_STAT,apply temporary stack  
         if(print->variant()==WRITE_STAT)  
             apply_temp_stack(doloop,iref,tileSize);

         // set_global_major in favor of the symbol printed.
	 SgSymbol *sym = iref->symbol();
	 int storage = getArrayStorage(sym);
	   // in case of fortran io, we force the buffer to column-major
/*  ???????????
	 if(ioMode == IO_FORTRAN)
	  if (storageMode != COLUMN_MAJOR)
	  {
	   SgStatement *stmt;
	   stmt = make_set_global_major(print, COLUMN_MAJOR);
	   doloop->insertStmtBefore(*stmt, *doloop->controlParent());
	   stmt = make_set_global_major(print, storageMode);
	   doloop->insertStmtAfter(*stmt, *doloop->controlParent());
	  }
*/

	 if(ioMode == IO_C)
	  if (storage != storageMode)
	  {
	   SgStatement *stmt;
	   stmt = make_set_global_major(print, storage);
	   doloop->insertStmtBefore(*stmt, *doloop->controlParent());
	   stmt = make_set_global_major(print, storageMode);
	   doloop->insertStmtAfter(*stmt, *doloop->controlParent());
	  }

       }      // end if(sub_print)

      }  //end of flag
      
        add_oc_read_or_write(ihdef,old_print,print,new_print,impdo_ioref[num][k],doloop,tileSize);
        
        iooc_flag[k]=1;
        cur_ioref_num=cur_ioref_num+1;
     }  //end of if(outofcore)

    else 
      {
        iooc_flag[k]=0;
         continue;
       } 
     //in one implied_do,when not finding Outofcore_Def, continue to look for 
    }

    if(flag)
       modify_print(old_print,new_print,ihdef,impdo_ioref[num],tileSize,iooc_flag,counter); 

     if (!flag)  // all are in_core in one implied_do
    {
      if((ioMode=IO_C) && (old_print->variant()!=PRINT_STAT))
       {
         int total=0,m;
         for(m=0; m<MAXVALUE;m++)
             if(impdo_ioref[num][m]!=-1) total=total+1;
         for(m=0; m<total; m++)
             rewriteIoStmt(old_print,impdo_ioref[num][m],print,0);
        }
      else
      {
        sub_print=construct_sub_print(impdoExp,speclist,print);
        if(sub_print)
           print->insertStmtBefore(*sub_print,*print->controlParent()); 
      }
    } 

     // next implied_do
     num ++;
//     exprlist=exprlist->rhs()?exprlist->rhs()->copyPtr():(SgExpression *)NULL;
    
   }  // end for impdo_num 

}

void insert_fileSeek(SgInputOutputStmt *print)
{
   SgExpression *speclist=print->specList()->copyPtr();
   SgExpression *expr;
   SgExpression *unitExp;
   SgExpression *recExp=NULL;
   for(expr=speclist; expr; expr=expr->rhs())
      {
        SgExpression *keyParent=expr->lhs();
        SgKeywordValExp *keyword=isSgKeywordValExp(keyParent->lhs());
        if(keyword != NULL )
        { 
           if(strcasecmp(keyword->value(),"unit")==0)
               unitExp=keyParent->rhs()->copyPtr();
           if(strcasecmp(keyword->value(),"rec")==0)
               recExp=keyParent->rhs()->copyPtr();
        }
       }
   if(recExp!=NULL)
   {
     SgSymbol *recSymb=print->getSymbolInCurrentScope(mixstring,"seek",NULL);
     SgCallStmt *seekStmt=new SgCallStmt(*recSymb);
     seekStmt->addArg(*unitExp);
     seekStmt->addArg(*recExp);
     print->insertStmtBefore(*seekStmt,*print->controlParent());
   }

}


void trans_iooc(SgInputOutputStmt * old_print,SgStatement *ifstmt,int *ioref_dim_num)
{
  int i,j;
 
  switch(ifstmt->variant())
  {  
    case LOGIF_NODE:
    {
      int org_numberOfChildren1=ifstmt->numberOfChildrenList1();

      SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];

      int org_numberOfChildren2=ifstmt->numberOfChildrenList2();

      SgStatement * * children2 = new SgStatement * [org_numberOfChildren2];

      for (i=0; i<org_numberOfChildren1; i++)
        children1[i]=ifstmt->childList1(i);

      for (i=0; i<org_numberOfChildren1; i++)
        trans_iooc(old_print,children1[i],ioref_dim_num);
      
      delete [] children1;

      for (i=0; i<org_numberOfChildren2; i++)
        children2[i]=ifstmt->childList2(i);                 
                                                                  
     for (i=0; i<org_numberOfChildren2; i++)
        trans_iooc(old_print,children2[i],ioref_dim_num);
      
      delete [] children2;
      break;
     }

    case READ_STAT:
    case WRITE_STAT:
    case PRINT_STAT:
        {
         if (old_print->numberOfAttributes(IHDER_Def) >0 ) 
        {
         for(i=0;i<MAXVALUE;i++)
           for(j=0;j<MAXVALUE;j++) 
               impdo_ioref[i][j]=-1;

         impdo_ioref_relation(old_print);
         if(isIooc(old_print)==1)
         {
           char *string;
           if(ifstmt->variant()==READ_STAT) string="read";
           if(ifstmt->variant()==WRITE_STAT) string="write";
           if(ifstmt->variant()==PRINT_STAT) string="print";

if (!silentFlag)
{
printf("BEGIN: out_of_core I/O--------%s\n",string);
printf("===warning:if format control appear in read/write, not responsible for result.\n");
}

         // at this time ,old_print and ifstmt are same
         // but attributes(IHDER_Def,Io_Ref) is still in old_print

	 int org_ioMode = ioMode;
	   // we donot translate format IO in C.
         if (is_format_io(old_print)) {
                ioMode = IO_FORTRAN;
         }

         if(ioMode==IO_C) {
           if((old_print->variant()==READ_STAT) || (old_print->variant()==WRITE_STAT))
             insert_fileSeek((SgInputOutputStmt *)ifstmt);
         }
         add_iooc_coef(old_print,(SgInputOutputStmt *)ifstmt);
         split_impdo(old_print,(SgInputOutputStmt *)ifstmt,ioref_dim_num);
         ifstmt->deleteStmt();

	   // recover ioMode 
	 ioMode = org_ioMode;

if (!silentFlag)
{
printf("END: out_of_core I/O----------%s\n",string);
printf("\n");
}
         }
        } 
         else
            if (isIooc(old_print)==1)
               printf("Sorry, now ignore read_write_print of non_implied_do &&  out_of_core\n"); 
         break;
       }
 
  } //end of switch

}
